<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<!-- IGAC proyecto SNC 

@author: javier.aponte 									
@description Pantalla de la actividad corespondiente a establecer procedencia de la solicitud 
@version 2.0
@cu CU-CO-A-01
@modified lorena.salamanca Se actualiza para la migracion de PrimeFaces 3.2 
@modified juanfelipe.garcia ajuste en las condiciones de generar documento 
                            y adición de inconsistencias geográficas CC-NP-CO-007
@modified juanfelipe.garcia adición de observaciones- Por rechazo depuración CC-NP-CO-026
@modified juanfelipe.garcia Controlar trámites con condición 8- 9 en determinar procediencia CC-NP-CO-040
@modified leidy.gonzalez Se elimina banderaRechazarTramite en el target del boton Rechazar Tramite.
-->

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:p="http://primefaces.org/ui"
                xmlns:tramite="http://java.sun.com/jsf/composite/tramite"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                xmlns:predio="http://java.sun.com/jsf/composite/predio"
                template="/templates/generalCU.xhtml">

    <ui:define name="content">
        <p:messages id="msgsProcedenciaSolicitud" showDetail="false"
                    globalOnly="false" />
        <p:ajaxStatus onstart="statusDialog.show();"
                      onsuccess="statusDialog.hide();" />

        <p:spacer height="30" width="0" />

        <p:fieldset toggleable="true" toggleSpeed="500">

            <legend> 
                <h:outputLabel value="Establecer procedencia de la solicitud" styleClass="legendTitle" /> 
            </legend>

            <tramite:tramiteResumen id="tabsgridI"
                                    tramiteParam="#{estableceProcedenciaSolicitud.tramite}" muestraTipoSolicitudParam="true"
                                    muestraClasificacionParam="true" muestraFechaRadicacionParam="true" muestraFechaSolicitudParam="true" />

            <p:fieldset id="noFichaFS" rendered="#{!estableceProcedenciaSolicitud.banderaHabilitarTramiteVisible}" styleClass="inline-block" 
                        style="display:inline-block; 
                        color: #D8000C;
                        background-color: #0000FF" >
                <legend>
                    <h:outputText value="No existe la información de las fichas matriz  de los predios con condición 8 o 9 y por lo tanto no puede seguir el trámite." 
                                  styleClass="legendTitle" />
                </legend>
            </p:fieldset>
            <p:fieldset id="validandoFS" rendered="#{estableceProcedenciaSolicitud.banderaValidandoAsincrono}" styleClass="inline-block" 
                        style="display:inline-block; 
                        color: #65B43D;" >
                <legend>
                    <h:outputText value="Se esta realizando la validación de la geometría. Esto puede tardar unos minutos" 
                                  styleClass="legendTitle" />
                </legend>
            </p:fieldset>

            <br/>   
            <br/>

            <h:form prependId="false" id="procedenciaSolicitudForm">	

                <h:panelGrid columns="1" cellspacing="5" cellpadding="5" width="40%" rendered="#{estableceProcedenciaSolicitud.mostrarInconsistenciasGeograficas}">

                    <h:outputLabel value="Inconsistencias geográficas:"
                                   styleClass="outputLabelStyle" />

                    <p:dataTable id="inconsistenciasTable"
                                 widgetVar="inconsistenciasTableWV"
                                 value="#{estableceProcedenciaSolicitud.inconsistenciasGeograficas}"
                                 var="inconsistencia" paginator="true" rows="5"
                                 paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                 rowsPerPageTemplate="5,10,15" paginatorPosition="bottom"
                                 emptyMessage="No hay inconsistencias asociadas">

                        <p:column headerText="Tipo">
                            <h:outputText id="PredioTipoV" value="#{inconsistencia.tipo}" />
                        </p:column>

                        <p:column headerText="Descripción">
                            <h:outputText value="#{inconsistencia.inconsistencia}" />

                        </p:column>
                        <p:column headerText="Número predial">
                            <h:outputText value="#{inconsistencia.numeroPredial}"
                                          styleClass="outputTextStyle" />
                        </p:column>
                    </p:dataTable>

                </h:panelGrid>    

                <p:spacer height="50" width="0" />

                <h:panelGrid columns="1" rendered="#{estableceProcedenciaSolicitud.habilitarRazonesRechazoDepuracion}">
                    <h:panelGrid width="450" columns="1" id="razonesRechazoDepuracionPG">
                        <h:panelGroup>
                            <h:outputLabel value="Razones rechazo depuración:" 
                                           for="razonesRechazoDepuracionEditor" styleClass="outputLabelStyle" />
                        </h:panelGroup>
                        <p:spacer height="10" width="0" />
                        <p:editor value="#{estableceProcedenciaSolicitud.razonesRechazoDepuracion}"
                                  id="razonesRechazoDepuracionEditor"
                                  disabled="true"
                                  widgetVar="motivoWV" width="400" height="150" />
                    </h:panelGrid>
                </h:panelGrid>
                <p:spacer height="100" width="0" rendered="#{estableceProcedenciaSolicitud.randomSpacer ==1}" />
                <p:spacer height="150" width="0" rendered="#{estableceProcedenciaSolicitud.randomSpacer ==2}" />
                <p:spacer height="200" width="0" rendered="#{estableceProcedenciaSolicitud.randomSpacer ==3}" />
       <h:panelGrid columns="2">
                <h:panelGrid columns="7" rendered="#{estableceProcedenciaSolicitud.banderaTramiteSoportado 
                                                     and estableceProcedenciaSolicitud.banderaGeometriaPrediosValidada}">
                    <p:commandButton icon="ui-icon-seek-next" id="botonAdmitirTramite"
                                     onclick="statusDialog2.show()"
                                     value="Admitir Trámite" onstart="statusDialog2.show();"
                                     oncomplete="statusDialog2.hide();" ajax="false"
                                     title="Admitir el trámite y moverlo a asignación de ejecutor"
                                     rendered="#{!estableceProcedenciaSolicitud.tramite.tramiteDeAutoavaluo
                                                 and estableceProcedenciaSolicitud.habilitarBotonAdmitir
                                                 and !estableceProcedenciaSolicitud.tramite.tramitesActualizacionRelacionados}"
                                     action="#{estableceProcedenciaSolicitud.admitirTramite}" 
                                     disabled="#{estableceProcedenciaSolicitud.tramiteEstadoBloqueo}"/>

                    <p:commandButton icon="ui-icon-seek-next" id="botonAdmitirTramiteAutoavaluo"
                                     value="Admitir Trámite"
                                     title="Admitir el trámite y moverlo a asignación de ejecutor (Autoavaluo)"
                                     rendered="#{estableceProcedenciaSolicitud.tramite.tramiteDeAutoavaluo
                                                 and estableceProcedenciaSolicitud.habilitarBotonAdmitir 
                                                 and !estableceProcedenciaSolicitud.tramite.tramitesActualizacionRelacionados}"
                                     action="#{estableceProcedenciaSolicitud.admitirTramiteAutoavaluo}" disabled="#{estableceProcedenciaSolicitud.tramiteEstadoBloqueo}"
                                     oncomplete="numeroTramiteWV.show()"/>

                    <p:spacer width="30" height="0" />
                    <p:commandButton value="Rechazar trámite" process="@this" icon="ui-icon-closethick" title="#{estableceProcedenciaSolicitud.tramite.tramitesActualizacionRelacionados}"
                                     rendered="#{estableceProcedenciaSolicitud.habilitarBotonRechazarTramite or 
                                                 estableceProcedenciaSolicitud.tramite.tramitesActualizacionRelacionados}"
                                     update=":msgsProcedenciaSolicitud, :procedenciaSolicitudForm:rechazarTramite">
                        <f:setPropertyActionListener target="#{estableceProcedenciaSolicitud.banderaRechazarTramite}"
                                                     value="true" />
                    </p:commandButton>

                    <p:spacer width="30" height="0" />

                    <p:commandButton icon="ui-icon-seek-next" id="botonEnviarADepurar"
                                     value="Enviar a depurar información geográfica"
                                     title="Enviar a depurar información geográfica"
                                     onstart="statusDialog2.show();"
                                     disabled="#{estableceProcedenciaSolicitud.tramiteEstadoBloqueo}"
                                     oncomplete="confirmarDepuracionWV.show();statusDialog2.hide();"
                                     rendered="#{estableceProcedenciaSolicitud.habilitarBotonEnviarADepurar
                                                 and !estableceProcedenciaSolicitud.tramite.tramitesActualizacionRelacionados
                                                 and !estableceProcedenciaSolicitud.banderaManzanaActualizacion}">

                    </p:commandButton>


                </h:panelGrid>

                <h:panelGrid rendered="#{estableceProcedenciaSolicitud.banderaTramiteSoportado 
                                         and estableceProcedenciaSolicitud.habilitarBotonValidarInconsistencias 
                                         and !estableceProcedenciaSolicitud.banderaValidandoAsincrono
                                         and !estableceProcedenciaSolicitud.tramite.tramitesActualizacionRelacionados}" >
                    <h:outputText styleClass="outputLabelStyle" rendered="#{empty estableceProcedenciaSolicitud.inconsistenciasGeograficas}"
                                  value="Aún no se ha validado la geometría de los predios por favor intente más tarde, o pulse en validar inconsistencias, esta 
                                  operación puede tardar algunos minutos"/>

                    <h:panelGrid columns="3">
                        <p:commandButton icon="ui-icon-seek-next" id="botonValidarDeNuevo"
                                         value="Validar inconsistencias"
                                         title="Validar inconsistencias"
                                         disabled="#{estableceProcedenciaSolicitud.tramiteEstadoBloqueo}"
                                         process="@form" update="procedenciaSolicitudForm, :msgsProcedenciaSolicitud, :validandoFS, :procedenciaSolicitudForm"
                                         action="#{estableceProcedenciaSolicitud.validarInconsistenciasDeNuevo}">
                        </p:commandButton>

                        <p:spacer width="30" height="0" />

                        <p:commandButton value="Rechazar trámite" process="@this" icon="ui-icon-closethick" title="#{estableceProcedenciaSolicitud.tramite.tramitesActualizacionRelacionados}"
                                         rendered="#{(estableceProcedenciaSolicitud.habilitarBotonRechazarTramite or 
                                                     estableceProcedenciaSolicitud.tramite.tramitesActualizacionRelacionados)
                                                     and !(estableceProcedenciaSolicitud.banderaTramiteSoportado 
                                                     and estableceProcedenciaSolicitud.banderaGeometriaPrediosValidada)}"
                                         update=":msgsProcedenciaSolicitud, :procedenciaSolicitudForm:rechazarTramite">
                            <f:setPropertyActionListener target="#{estableceProcedenciaSolicitud.banderaRechazarTramite}"
                                                         value="true" />
                        </p:commandButton>
                    </h:panelGrid>

                    <p:blockUI block=":procedenciaSolicitudForm" trigger="botonValidarDeNuevo" >
                        Validando la geometría de los predios. Por favor espere...
                        <p:graphicImage value="/images/loading.gif"/>
                    </p:blockUI>

                </h:panelGrid>
             </h:panelGrid>   

                <h:panelGrid rendered="#{!estableceProcedenciaSolicitud.banderaTramiteSoportado}" >
                    <h:outputText styleClass="outputLabelStyle" 
                                  value="Esta funcionalidad no está implementada en el sistema"/>
                </h:panelGrid>

                <h:panelGrid rendered="#{estableceProcedenciaSolicitud.tramite.tramitesActualizacionRelacionados}" >
                    <h:outputText styleClass="outputLabelStyle" style="color: green;"
                                  value="Tramite con predios en proceso de actualización"/>
                </h:panelGrid>

                <h:panelGrid rendered="#{estableceProcedenciaSolicitud.banderaManzanaActualizacion and estableceProcedenciaSolicitud.tramite.tramiteGeografico}" >
                    <h:outputText styleClass="outputLabelStyle" style="color: green;"
                                  value="Existen predios en proceso de actualización en esta manzana, no se puede enviar el trámite a depuración"/>
                </h:panelGrid>

                <p:spacer height="30" width="0" />



                <h:panelGrid columns="1" width="100%" id="rechazarTramite">
                    <p:fieldset 
                        rendered="#{estableceProcedenciaSolicitud.banderaRechazarTramite}"
                        toggleable="true" toggleSpeed="500">

                        <legend> <h:outputLabel value="Rechazo de trámite" styleClass="legendTitle" /> </legend>

                        <h:panelGrid columns="1">
                            <h:panelGrid columns="2">
                                <h:outputLabel value="Motivo rechazo:"
                                               styleClass="outputLabelStyle" />
                                <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                            </h:panelGrid>
                            <h:panelGrid columns="2">
                                <h:inputTextarea value="#{estableceProcedenciaSolicitud.estadoTramite.motivo}"
                                                 id="motivoRechazo" required="true" label="Motivo rechazo"
                                                 disabled="#{estableceProcedenciaSolicitud.banderaDocumentoRadicado}" 
                                                 onkeydown="controlarNroChars(this, 2000, true);"
                                                 onkeyup="controlarNroChars(this, 2000, true);"
                                                 rows="3" cols="150" />
                                <p:message for="motivoRechazo" display="icon" id="motivoRechazoMsg" />
                            </h:panelGrid> 
                        </h:panelGrid>
                        <h:panelGrid columns="3">
                            <p:commandButton value="Guardar" disabled="#{estableceProcedenciaSolicitud.banderaDocumentoRadicado}" 
                                             update="generarDocumentoBtn, motivoRechazoMsg, :msgsProcedenciaSolicitud" icon="ui-icon-disk" 
                                             process="motivoRechazo, @this"
                                             action="#{estableceProcedenciaSolicitud.guardarMotivoRechazoTramite}" 
                                             id="guardarBtn">
                                <f:setPropertyActionListener target="#{estableceProcedenciaSolicitud.banderaGuardarMotivo}" 
                                                             value="true" />
                            </p:commandButton>
                            <p:spacer width="50" height="0" />
                            <p:commandButton value="Generar documento" id="generarDocumentoBtn"  rendered="#{!estableceProcedenciaSolicitud.tramiteEstadoBloqueo}"
                                             icon="ui-icon-document-b"
                                             disabled="#{!estableceProcedenciaSolicitud.banderaGuardarMotivo or estableceProcedenciaSolicitud.banderaDocumentoRadicado}"
                                             onstart="statusDialog2.show()"
                                             oncomplete="statusDialog2.hide();visorReporteWV.show();"
                                             action="#{estableceProcedenciaSolicitud.generarOficioNoProcedencia}" 
                                             update=":viewReport:vistaMemoForm,procedenciaSolicitudForm, :msgsProcedenciaSolicitud"/>
                        </h:panelGrid>
                    </p:fieldset>
                </h:panelGrid>


                <p:spacer height="30" width="0" />

            </h:form>

            <h:form prependId="false" id="cerrarProcedenciaSolicitudForm">	
                <p:separator style="width:90%;height:3px" />
                <p:spacer height="7" width="0" />
                <p:outputPanel layout="block" style="text-align:right">
                    <p:commandButton value="Cerrar" 
                                     icon="ui-icon-circle-close" 
                                     action="#{estableceProcedenciaSolicitud.cerrarEstableceProcedenciaSolicitudIndividual}"
                                     ajax="false" />
                    <p:spacer height="0" width="30" />
                </p:outputPanel>
            </h:form>
        </p:fieldset>

        <p:dialog header="Detalle del trámite"
                  widgetVar="detalleTramiteEjecutarWV" modal="false" appendToBody="true"
                  resizable="true" position="center" height="480" width="960">
            <ui:include
                src="/conservacion/ejecucion/detalleTramiteEjecucion.xhtml">
                <ui:param name="currentManagedBeanParam"
                          value="#{vistaDetallesTramite}" />
                <ui:param name="currentDetallePredioWV" value="detallePredioWV" />
                <ui:param name="permiteSubirArchivos" value="false" />
            </ui:include>
        </p:dialog>


        <predio:detallesPredioCC id="dpCC" thisWVName="detallePredioWV"
                                 mostrarDatosPropietarios="true" mostrarDatosTramites="true"
                                 mostrarFichaPredial="true" thisIdPlusColon=":dpCC" />

        <!-- Dialog usado para habilitar el tab de origen del predio -->
        <predio:detallesPredioCC id="dpCC2" thisWVName="detallePredioWV2"
                                 mostrarDatosPropietarios="true" mostrarDatosTramites="true"
                                 mostrarFichaPredial="true" thisIdPlusColon=":dpCC2" />

        <misc:docViewerWithCloseDecisionCC id="docViewer"
                                           confirmUpdate="msgInfoFis" confirmDialogWV="docViewerWV"
                                           ajaxBehavior="true"
                                           selectedDocumentAtt="#{previsualizacionDocumento.rutaArchivoTemporal}"
                                           showDownloadButton="#{previsualizacionDocumento.documentoDwg}"
                                           fileContent="#{previsualizacionDocumento.reporteDTO.streamedContentReporte}"
                                           doctypeAtt="#{vistaDetallesTramite.tipoMimeDocTemporal}"
                                           headerLabel="Previsualización de documento" yesRendered="false"
                                           noLabel="Cerrar" />	


        <p:dialog header="Detalle de la solicitud" dynamic="true"
                  widgetVar="detalleSolicitudWV" modal="true" appendToBody="true"
                  resizable="true" position="center" height="480" width="960">
            <ui:include
                src="/conservacion/ejecucion/detalleSolicitudEjecutar.xhtml">
                <ui:param name="currentManagedBeanParam"
                          value="#{vistaDetallesSolicitud}" />
                <ui:param name="selectedSolicitudParam"
                          value="#{estableceProcedenciaSolicitud.solicitud}" />
                <ui:param name="tramiteResumenID"
                          value="#{cc.attrs.tramiteResumenID}" />
            </ui:include>
        </p:dialog>

        <p:dialog header="Confirmación número de trámite autoavaluo" dynamic="true"
                  widgetVar="numeroTramiteWV" modal="true" appendToBody="true" closable="false"
                  resizable="true" position="center">
            <h:form>
                <h:panelGrid cellspacing="5" cellpadding="5">
                    <h:outputText value="#{estableceProcedenciaSolicitud.mensajeConfirmationAvanzarProceso}" 
                                  styleClass="outputTextStyle"/>
                    <p:commandButton value="Aceptar" action="#{estableceProcedenciaSolicitud.moverProcesoIsCuarta}" 
                                     ajax="false" icon="ui-icon-check"/>
                </h:panelGrid>
            </h:form>
        </p:dialog>

        <misc:visualizadorMemorandosCC
            id="viewReport"
            thisWVName="visorReporteWV"
            nombreDialogo="Oficio"
            urlDocumento="#{estableceProcedenciaSolicitud.oficioNoProcedencia.urlWebReporte}"
            fileContent="#{estableceProcedenciaSolicitud.oficioNoProcedencia.streamedContentReporte}"
            documentoGenerado="#{estableceProcedenciaSolicitud.oficioNoProcedencia ne null}"
            radicarButtonAction="#{estableceProcedenciaSolicitud.radicar}"
            radicarButtonEnabled="#{!estableceProcedenciaSolicitud.banderaDocumentoRadicado}"
            componentsToUpdateOnClose=":procedenciaSolicitudForm"
            cancelButtonEnabled="false"
            cancelButtonVisible="false"/>

        <misc:ultimateConfirmDialogCC
            confirmMessage="¿Esta seguro de enviar este trámite a depuración?"
            confirmDialogWV="confirmarDepuracionWV"
            additionalActionOnYes=";confirmarGeneracionReplicaWV.show();"
            yesLabel="Aceptar" noLabel="Cancelar" 
            />

        <misc:ultimateConfirmDialogCC
            confirmMessage="Se debe generar la réplica de consulta, esto tomará unos minutos."
            confirmDialogWV="confirmarGeneracionReplicaWV"
            stringActionOnYes="#{estableceProcedenciaSolicitud.enviarADepurarInformacionGeografica}"
            yesLabel="Aceptar" noLabel="Cancelar" 
            additionalActionOnYes="statusDialog2.show();"
            useStringActionOnYes="true" />


        <ui:include src="/util/visorGeografico.xhtml" />

    </ui:define>
</ui:composition>